l<template>
  <v-app>
    <v-dialog v-model="dialogBizAccount" width="350">
      <v-card>
        <v-spacer></v-spacer>
        <v-toolbar-items style="padding-right:10px;">
          <v-btn icon @click="dialogBizAccount = false">
            <v-icon color="#6a7d69">mdi-close</v-icon>
          </v-btn>
        </v-toolbar-items>
        <v-layout class="justify-center">
          <div style="color:black;">
            <img :src="images.bizaccount" style="width:220px;" />
          </div>
        </v-layout>
        <v-card-title
          class="justify-center"
          style="color:#6a7d69; font-size:18px;"
          >BUSINESS ACCOUNT</v-card-title
        >
        <div class="dialogBBL">
          <strong style="color:#6a7d69;">STEP 1 :</strong> Sign up business
          account by following step from
          <a
            style="color:#6a7d69;"
            href="/User_Manual_Business.pdf"
            target="blank"
            >manual</a
          ><br />
          <strong style="color:#6a7d69;">STEP 2 :</strong> Create position
          'admin-ipay'<br />
          <strong style="color:#6a7d69;">STEP 3 :</strong> Add employee in this
          position
        </div>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogloader" persistent content-class="elevation-0">
      <v-layout class="justify-center">
        <v-card color="transparent" class="elevation-0">
          <self-building-square-spinner
            :animation-duration="2000"
            :size="70"
            color="white"
          />
        </v-card>
      </v-layout>
    </v-dialog>

    <v-content
      style="background-color: #d2e7c2;background-repeat: no-repeat;background-size: cover;"
      :style="{
        backgroundImage: 'url(' + require('@/assets/vector-2.png') + ')'
      }"
    >
      <v-container fill-height>
        <v-card
          class="mx-auto my-12 rounded-card"
          elevation="2"
          width="100%"
          height="100%"
        >
          <v-layout>
            <v-flex md7 xs7>
              <div>
                <img
                  :src="images.logoinet"
                  style="padding-left:10px;padding-top:10px"
                />
              </div>
              <center><img :src="images.computer" class="img-com" /></center>
            </v-flex>

            <v-flex md5 xs5>
              <span class="text-title">Login</span>
              <span class="text-subtitle">
                Login with your data that you entered during your registration.
              </span>

              <div v-if="!mobileView">
                <v-card-text class="login layoutlogin loginicon" color="white">
                  <span class="text">Username</span>
                  <v-text-field
                    outline
                    placeholder="Username"
                    name="username"
                    v-model="username"
                    ref="username"
                    :rules="[() => !!username || 'This field is required']"
                  ></v-text-field>
                  <span class="text">Password</span>
                  <v-text-field
                    outline
                    placeholder="Password"
                    v-model="password"
                    ref="password"
                    :append-icon="showUsername ? 'mdi-eye' : 'mdi-eye-off'"
                    :type="showUsername ? 'text' : 'password'"
                    :rules="[() => !!password || 'This field is required']"
                    @click:append="showUsername = !showUsername"
                  ></v-text-field>
                  <span class="text">Tax ID</span>
                  <v-text-field
                    outline
                    placeholder="Tax ID"
                    v-model="taxid"
                    name="taxid"
                    ref="taxid"
                    :rules="[() => !!taxid || 'This field is required']"
                  ></v-text-field>
                </v-card-text>

                <div class="layoutlogin" style="margin-top:5px">
                  <v-layout>
                    <v-flex md6 xs6>
                      <!-- <v-checkbox
                      v-model="checkbox"
                      :label="`Keep me logged in`"
                      style="margin-top:0;padding-top:0;color: #AEAEAE;"
                    ></v-checkbox> -->
                    </v-flex>
                    <v-flex md6 xs6>
                      <a
                        href="https://one.th/type_forgot_password"
                        target="_blank"
                        color="#efdbd4"
                        class="forgotpassword"
                        >Forgot password?
                      </a>
                    </v-flex></v-layout
                  >
                </div>

                <v-card-actions class="layoutlogin">
                  <v-btn
                    class="loginbtn white--text"
                    style="margin:0px 10px; background-color:#3A8300; box-shadow: 1px 1px 10px 1px rgb(172, 185, 172)"
                    round
                    block
                    @click="login()"
                    >Login
                  </v-btn>
                </v-card-actions>

                <div class="layoutlogin">
                  <p
                    class="text-normal"
                    style="margin-bottom: 16px;font-family: Sarabun, sans-serif;"
                  >
                    Don't have an account?
                    <a
                      href="https://one.th/register"
                      target="_blank"
                      class="text-signup"
                      >Sign up</a
                    >
                  </p>
                </div>
              </div>
            </v-flex>
          </v-layout>

          <!-- --------------------------- mobileView ------------------------------ -->
          <div v-if="mobileView" style="margin: 20px;">
            <span class="text">Username</span>
            <v-text-field
              outline
              placeholder="Username"
              name="username"
              v-model="username"
              ref="username"
              :rules="[() => !!username || 'This field is required']"
            ></v-text-field>
            <span class="text">Password</span>
            <v-text-field
              outline
              placeholder="Password"
              v-model="password"
              ref="password"
              :append-icon="showUsername ? 'mdi-eye' : 'mdi-eye-off'"
              :type="showUsername ? 'text' : 'password'"
              :rules="[() => !!password || 'This field is required']"
              @click:append="showUsername = !showUsername"
            ></v-text-field>
            <span class="text">Tax ID</span>
            <v-text-field
              outline
              placeholder="Tax ID"
              v-model="taxid"
              name="taxid"
              ref="taxid"
              :rules="[() => !!taxid || 'This field is required']"
            ></v-text-field>

            <div style="margin-top:5px">
              <v-layout>
                <v-flex md6 xs6> </v-flex>
                <v-flex md6 xs6>
                  <a
                    href="https://one.th/type_forgot_password"
                    target="_blank"
                    color="#efdbd4"
                    class="forgotpassword"
                    >Forgot password?
                  </a>
                </v-flex>
              </v-layout>
            </div>

            <v-card-actions>
              <v-btn
                class="loginbtn white--text"
                style="margin:0px 10px; background-color:#3A8300; box-shadow: 1px 1px 10px 1px rgb(172, 185, 172)"
                @click="login"
                round
                block
                >Login
              </v-btn>
            </v-card-actions>

            <div>
              <p
                class="text-normal"
                style="margin-bottom: 16px;font-family: Sarabun, sans-serif;"
              >
                Don't have an account?
                <a
                  href="https://one.th/register"
                  target="_blank"
                  class="text-signup"
                  >Sign up</a
                >
              </p>
            </div>
          </div>
        </v-card>
      </v-container>
    </v-content>
  </v-app>
</template>

<script>
import { sync } from "vuex-pathify";
import { TextEncoder } from "text-encoding";
import { sha256, sha224 } from "js-sha256";
// import {SemipolarSpinner} from 'epic-spinners'
import { SelfBuildingSquareSpinner } from "epic-spinners";
if (!window["TextEncoder"]) {
  window["TextEncoder"] = TextEncoder;
}
export default {
  components: {
    SelfBuildingSquareSpinner
  },
  data() {
    return {
      dialogBizAccount: false,
      fileName: "",
      isFile: false,
      mobileView: false,
      dialogMkey: false,
      emailCompany: "",
      showUsername: false,
      emailRules: [
        v => !!v || "E-mail is required",
        v =>
          /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) ||
          "E-mail must be valid"
      ],
      username: "",
      password: "",
      taxid: "",

      // username: 'chocolee',
      // password: 'z6nkd11u',
   username: 'apatsarapron',
      password: 'patt24101606',

      // taxid: '8730033529204', // biz GG
      // taxid: '8500968780904', // biz GG Payment
      // taxid: '6028138436378', // biz Abc

      taxid: "0107544000094", // INET
      // taxid: "0105560058105", // TDC

      getname: "",
      firstname: "",
      images: {
        logo: require("../assets/inetlogo.png"),
        bizaccount: require("../assets/bizaccount.png"),
        logoinet: require("../assets/inet.png"),
        computer: require("../assets/computer.png")
      },
      mkey: "",
      userData: "",
      dialogloader: false,
      checkbox: false,
      datapic: ""
    };
  },
  watch: {
    dialogMkey(val) {
      val || this.close();
    }
  },
  methods: {
    setFileName() {
      this.fileName = this.$refs.fileExcel.files[0].name;
      this.isFile = true;
    },
    clearFile() {
      this.isFile = false;
      this.fileName = "";
      this.$refs.formExcel.reset();
    },
    close() {
      this.$refs["mkey"].reset();
      this.$refs["emailCompany"].reset();
      this.dialogMkey = false;
    },
    async save() {
      if (!this.mkey || !this.emailCompany) {
        this.$refs["mkey"].validate(true);
        this.$refs["emailCompany"].validate(true);
      } else if (!this.isFile) {
        alert("Select file image");
      } else {
        let taxidBuff = new Buffer(this.taxid + " ");
        let taxidBase64 = taxidBuff.toString("base64");
        // console.log('/file: ', this.$refs.fileExcel.files[0])
        if (this.$refs.fileExcel.files[0].size > 25001) {
          // 10kb
          alert("image size more than 25 KB");
        } else if (this.fileName == "") {
          alert("Please select company logo");
        } else {
          var data = new FormData();
          data.append("sub", taxidBase64);
          data.append("mkey", this.mkey);
          data.append("nameTH", this.userData.company_name_th);
          data.append("nameENG", this.userData.company_name_eng);
          data.append("email", this.emailCompany);
          data.append("createby", this.username);
          data.append("file", this.$refs.fileExcel.files[0]);
          var { data: data_upload } = await this.axios.post(
            `${process.env.VUE_APP_APIHOST}/add_company`,
            data,
            {
              headers: { Authorization: this.userData.token }
            }
          );
          // console.log('upload: ', data_upload)
          //admin if insert NEW logo and mkey
          if (data_upload.status === "Success") {
            this.clearFile();
            this.dialogMkey = false;
            this.$cookies.set("firstnameENG", this.userData.first_name_eng);
            this.$cookies.set(
              "nameENG",
              this.userData.first_name_eng + " " + this.userData.last_name_eng
            );
            this.$cookies.set(
              "firstlastTH",
              this.userData.first_name_th + " " + this.userData.last_name_th
            );
            this.$cookies.set("nameTH", this.userData.name_th);
            this.$cookies.set("bizNameTH", this.userData.company_name_th);
            this.$cookies.set("bizType", this.userData.company_type_eng);
            this.$session.start();
            this.$cookies.set("role", "Admin");
            this.$cookies.set("token", this.userData.token);
            this.$cookies.set("username", this.username);
            this.$router.push("/income");
          } else {
            alert(data_upload.status);
          }
        }
      }
    },
    checkField() {
      this.formHasErrors = false;
      Object.keys(this.form).forEach(f => {
        if (!this.form[f]) {
          this.formHasErrors = true;
        }
        this.$refs[f].validate(true);
      });
    },
    async login() {
      this.checkField();
      if (this.formHasErrors === false) {
        try {
          this.dialogloader = true;
          const taxIDhash = await this.digestMessage(this.taxid);
          let user_pass =
            this.username +
            " " +
            this.password +
            " " +
            this.taxid +
            " " +
            taxIDhash;
          let buff = new Buffer(user_pass);
          let base64data = buff.toString("base64");
          // console.log("base64data: ", base64data);
          // console.log(process.env.VUE_APP_APIHOST + "/login_business");
          var { data } = await this.axios.post(
            process.env.VUE_APP_APIHOST + "/login_business",
            {
              source: base64data
            }
          );
          // console.log("login_business: ", data);
          if (data.status === "Success") {
            this.userData = data.data;
            this.datapic = data.pic;
            this.dialogloader = false;
            // this.$cookies.set("firstnameENG", this.userData.first_name_eng);
            // this.$cookies.set(
            //   "nameENG",
            //   this.userData.first_name_eng + " " + this.userData.last_name_eng
            // );
            this.$cookies.set(
              "firstlastTH",
              this.userData.first_name_th + " " + this.userData.last_name_th
            );
            // this.$cookies.set("nameTH", this.userData.name_th);
            this.$cookies.set("bizNameTH", this.userData.company_name_th);
            // this.$cookies.set("bizType", this.userData.company_type_eng);
            // localStorage.setItem("imageCompany", this.userData.image_company);
            this.$session.start();
            // this.$cookies.set('role', this.userData.role)
            this.$cookies.set("role", "User");
            this.$cookies.set("token", this.userData.token);

            // console.log('token');
            // console.log(  this.$cookies.get("token"));
            this.$cookies.set(
              "createdBy",
              this.userData.id + ":" + this.userData.thai_email
            );
            localStorage.setItem("image", this.datapic.pic);
            // console.log('username: ', this.$cookies.get("username"));
            // if (this.userData.role === 'User'){
            this.$router.push("/unpaidbill");
          } else {
            alert(data.status);
            this.dialogloader = false;
          }
        } catch (error) {
          console.log(error.message);
        }
      } else {
        this.checkField();
      }
    },
    async digestMessage(salt) {
      const msgUint8 = new TextEncoder().encode(salt); // encode as (utf-8) Uint8Array
      const hashBuffer = await window.crypto.subtle.digest("SHA-256", msgUint8); // hash the message
      const hashArray = Array.from(new Uint8Array(hashBuffer)); // convert buffer to byte array
      const hashHex = hashArray
        .map(b => b.toString(16).padStart(2, "0"))
        .join(""); // convert bytes to hex string
      // console.log('hashHex: ', hashHex)
      return hashHex;
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    clearCookie() {
      this.$cookies.keys().forEach(key => {
        if (key !== "checkchkbox") {
          let keyremove = key;
          this.$cookies.remove(keyremove);
        }
      });
    }
  },
  computed: {
    exportfrom: sync("exportfrom"),
    form() {
      return {
        username: this.username,
        password: this.password,
        taxid: this.taxid
      };
    }
  },
  created() {
    this.handleView();
    this.clearCookie();
    window.addEventListener("resize", this.handleView);
  }
};
</script>

<style>
.v-card__text.login {
  padding: 16px 16px 0px 16px !important;
}
.rounded-card {
  border-radius: 15px;
}
.loginbtn {
  text-align: center;
  border-radius: 4px;
  font-family: "Sarabun", sans-serif;
  font-weight: bold;
}
.forgotpassword {
  text-decoration: none;
  color: #3a8300;
  font-style: normal;
  font-weight: bold;
  font-size: 14px;
  line-height: 22px;
  float: right;
  padding-right: 20px;
  padding-top: 4px;
  font-family: "Sarabun", sans-serif;
  /* text-decoration: underline; */
}
.loginicon .v-input__icon--prepend .v-icon {
  color: #6a7d69;
}
.loginres {
  display: -webkit-flex;
  display: flex;
}
.layoutlogin {
  max-width: 80%;
  min-width: 80%;
}
.regisbiz {
  width: 12px;
  height: 12px;
}
.dialogBBL {
  padding: 0px 15px 25px 25px;
}
.logoinet {
  size: 58px;
}
@media (max-width: 500px) {
  .logoinet {
    size: 48px;
  }
  .loginres {
    width: 100%;
  }
  .v-card#loginBox {
    width: 80%;
  }
  .btn.loginbtn {
    width: 20%;
  }
}

@media (min-width: 1264px) {
  .container {
    max-width: 100%;
  }
}

.img-com {
  width: 70%;
}

.text-title {
  font-style: normal;
  font-weight: bold;
  font-size: 50px;
  line-height: 88px;
  display: flex;
  align-items: center;
  color: #3a8300;
  padding-top: 50px;
  font-family: "Sarabun", sans-serif;
}

.text-subtitle {
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 24px;
  color: #aeaeae;
  flex: none;
  order: 1;
  align-self: stretch;
  flex-grow: 0;
  margin: 0px 0px;
  max-width: 80%;
  min-width: 80%;
  font-family: "Sarabun", sans-serif;
}

.text-normal {
  color: #aeaeae;
  text-align: center;
}

.text-signup {
  text-decoration: none;
  color: #3a8300;
  font-style: normal;
  font-weight: bold;
  margin: 16px 0px;
}

.rounded-card {
  border-radius: 20px !important;
}

.v-text-field--outline input {
  margin-top: 0px !important;
}

.v-text-field.v-text-field--enclosed .v-input__append-inner {
  margin-top: 4px !important;
}
</style>
